Index: GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp
===================================================================
--- GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp	(revision 1002)
+++ GTP/trunk/Lib/Vis/Preprocessing/src/VspOspTree.cpp	(revision 1006)
@@ -1512,80 +903,23 @@
 											nPosition[axis]);			
 			}
-			
-			//-- split plane position is spatial median
-
-
-			// also use median split if cost ratio very low as
-			// there are not enough visibility cues
-			//if (!mUseCostHeuristics || (nCostRatio[axis] > maxCostRatioForHeur))
-			else 
-			{
-
+			else //-- split plane position is spatial median
+			{
 				nPosition[axis] = (box.Min()[axis] + box.Max()[axis]) * 0.5f;
-				Vector3 normal(0,0,0); normal[axis] = 1.0f;
-
-				// allows faster split because we have axis aligned kd tree boxes
-				if (isKdNode)
-				{
-					nCostRatio[axis] = EvalAxisAlignedSplitCost(tData,
-																box,
-																axis,
-																nPosition[axis],
-																nProbFront[axis], 
-																nProbBack[axis]);
-					
-					Vector3 pos;
-					
-					// create back geometry from box
-					// NOTE: the geometry is saved when possible
-					pos = box.Max(); pos[axis] = nPosition[axis];
-					AxisAlignedBox3 bBox(box.Min(), pos);
-					PolygonContainer fPolys;
-					bBox.ExtractPolys(fPolys);
-
-					nBackGeom[axis] = new BspNodeGeometry(fPolys);
-	
-					//-- create front geometry from box
-					pos = box.Min(); pos[axis] = nPosition[axis];
-					AxisAlignedBox3 fBox(pos, box.Max());
-
-					PolygonContainer bPolys;
-					fBox.ExtractPolys(bPolys);
-					nFrontGeom[axis] = new BspNodeGeometry(bPolys);
-				}
-				else
-				{
-					nFrontGeom[axis] = new BspNodeGeometry();
-					nBackGeom[axis] = new BspNodeGeometry();
-
-					nCostRatio[axis] = 
-						EvalSplitPlaneCost(Plane3(normal, nPosition[axis]), 
-										   tData, *nFrontGeom[axis], *nBackGeom[axis],
-										   nProbFront[axis], nProbBack[axis]);
-				}
+
+				nCostRatio[axis] = EvalSplitCost(tData,
+												 box,
+												 axis,
+												 nPosition[axis],
+												 nProbFront[axis], 
+												 nProbBack[axis]);
 			}
 						
-			
-			if (mUseDrivingAxisForMaxCost)
-			{
-				// we take longest axis split if cost ratio exceeds threshold
-				if (nCostRatio[axis] < min(maxCostRatioForArbitraryAxis, nCostRatio[bestAxis]))
-				{
-					bestAxis = axis;
-				}
-				else if (nCostRatio[axis] < nCostRatio[bestAxis])
-					Debug << "taking split along longest axis (" << bestAxis << ") instead of  (" << axis << ")" << endl;
-				
-			}
-			else
-			{
-				if (bestAxis == -1)
-				{
-					bestAxis = axis;
-				}
-				else if (nCostRatio[axis] < nCostRatio[bestAxis])
-				{
-					bestAxis = axis;
-				}
+			if (bestAxis == -1)
+			{
+				bestAxis = axis;
+			}
+			else if (nCostRatio[axis] < nCostRatio[bestAxis])
+			{
+				bestAxis = axis;
 			} 
 		}
@@ -1593,246 +927,16 @@
 
 	//-- assign values
-	axis = bestAxis;
+	plane.mAxis = bestAxis;
 	pFront = nProbFront[bestAxis];
 	pBack = nProbBack[bestAxis];
 
-	// assign best split nodes geometry 
-	*frontGeom = nFrontGeom[bestAxis];
-	*backGeom = nBackGeom[bestAxis];
-
-	// and delete other geometry
-	DEL_PTR(nFrontGeom[(bestAxis + 1) % 3]);
-	DEL_PTR(nBackGeom[(bestAxis + 2) % 3]);
-
-	//-- split plane
-    Vector3 normal(0,0,0); normal[bestAxis] = 1;
-	plane = Plane3(normal, nPosition[bestAxis]);
-
-	//Debug << "best axis: " << bestAxis << " pos " << nPosition[bestAxis] << endl;
-	//Debug << "!!!!!!!!!!!!!!" << endl;
+	//-- split plane position
+    plane.mPosition = nPosition[bestAxis];
+
 	return nCostRatio[bestAxis];
 }
 
 
-bool VspBspTree::SelectPlane(Plane3 &bestPlane,
-							 BspLeaf *leaf,
-							 VspBspTraversalData &data,							 
-							 VspBspTraversalData &frontData,
-							 VspBspTraversalData &backData,
-							 int &splitAxis)
-{
-	// HACK matt: subdivide regularily to certain depth
-	if (data.mDepth < 0)  	
-	{
-		cout << "d: " << data.mDepth << endl;
-		// return axis aligned split
-		AxisAlignedBox3 box;
-		box.Initialize();
-	
-		// create bounding box of region
-		data.mGeometry->GetBoundingBox(box);
-	
-		const int axis = box.Size().DrivingAxis();
-		const Vector3 position = (box.Min()[axis] + box.Max()[axis]) * 0.5f;
-
-		Vector3 norm(0,0,0); norm[axis] = 1.0f;
-		bestPlane = Plane3(norm, position);
-		splitAxis = axis;
-		return true;
-	}
-
-	// simplest strategy: just take next polygon
-	if (mSplitPlaneStrategy & RANDOM_POLYGON)
-	{
-        if (!data.mPolygons->empty())
-		{
-			const int randIdx = 
-				(int)RandomValue(0, (Real)((int)data.mPolygons->size() - 1));
-			Polygon3 *nextPoly = (*data.mPolygons)[randIdx];
-
-			bestPlane = nextPoly->GetSupportingPlane();
-			return true;
-		}
-	}
-
-	//-- use heuristics to find appropriate plane
-
-	// intermediate plane
-	Plane3 plane;
-	float lowestCost = MAX_FLOAT;
-	
-	// decides if the first few splits should be only axisAligned
-	const bool onlyAxisAligned  = 
-		(mSplitPlaneStrategy & AXIS_ALIGNED) &&
-		((int)data.mRays->size() > mTermMinRaysForAxisAligned) &&
-		((int)data.GetAvgRayContribution() < mTermMaxRayContriForAxisAligned);
-	
-	const int limit = onlyAxisAligned ? 0 : 
-		Min((int)data.mPolygons->size(), mMaxPolyCandidates);
-
-	float candidateCost;
-
-	int maxIdx = (int)data.mPolygons->size();
-
-	for (int i = 0; i < limit; ++ i)
-	{
-		// the already taken candidates are stored behind maxIdx
-		// => assure that no index is taken twice
-		const int candidateIdx = (int)RandomValue(0, (Real)(-- maxIdx));
-		Polygon3 *poly = (*data.mPolygons)[candidateIdx];
-
-		// swap candidate to the end to avoid testing same plane
-		std::swap((*data.mPolygons)[maxIdx], (*data.mPolygons)[candidateIdx]);
-		//Polygon3 *poly = (*data.mPolygons)[(int)RandomValue(0, (int)polys.size() - 1)];
-
-		// evaluate current candidate
-		BspNodeGeometry fGeom, bGeom;
-		float fArea, bArea;
-		plane = poly->GetSupportingPlane();
-		candidateCost = EvalSplitPlaneCost(plane, data, fGeom, bGeom, fArea, bArea);
-		
-		if (candidateCost < lowestCost)
-		{
-			bestPlane = plane;
-			lowestCost = candidateCost;
-		}
-	}
-
-	//-- evaluate axis aligned splits
-	int axis;
-	BspNodeGeometry *fGeom, *bGeom;
-	float pFront, pBack;
-
-	candidateCost = 99999999.0f;
-
-	// option: axis aligned split only if no polygon available
-	if (!mUsePolygonSplitIfAvailable || data.mPolygons->empty())
-	{
-		candidateCost = SelectAxisAlignedPlane(plane, 
-											   data, 
-											   axis,
-											   &fGeom, 
-											   &bGeom, 
-											   pFront, 
-											   pBack,
-											   data.mIsKdNode);	 
-	}
-
-	splitAxis = 3;
-
-	if (candidateCost < lowestCost)
-	{	
-		bestPlane = plane;
-		lowestCost = candidateCost;
-		splitAxis = axis;
-	
-		// assign already computed values
-		// we can do this because we always save the
-		// computed values from the axis aligned splits		
-
-		if (fGeom && bGeom)
-		{
-			frontData.mGeometry = fGeom;
-			backData.mGeometry = bGeom;
-	
-			frontData.mProbability = pFront;
-			backData.mProbability = pBack;
-		}
-	}
-	else
-	{
-		DEL_PTR(fGeom);
-		DEL_PTR(bGeom);
-	}
-    
-#ifdef _DEBUG
-	Debug << "plane lowest cost: " << lowestCost << endl;
-#endif
-
-	// exeeded relative max cost ratio
-	if (lowestCost > mTermMaxCostRatio)
-	{
-		return false;
-	}
-
-	return true;
-}
-
-
-Plane3 VspBspTree::ChooseCandidatePlane(const RayInfoContainer &rays) const
-{
-	const int candidateIdx = (int)RandomValue(0, (Real)((int)rays.size() - 1));
-
-	const Vector3 minPt = rays[candidateIdx].ExtrapOrigin();
-	const Vector3 maxPt = rays[candidateIdx].ExtrapTermination();
-
-	const Vector3 pt = (maxPt + minPt) * 0.5;
-	const Vector3 normal = Normalize(rays[candidateIdx].mRay->GetDir());
-
-	return Plane3(normal, pt);
-}
-
-
-Plane3 VspBspTree::ChooseCandidatePlane2(const RayInfoContainer &rays) const
-{
-	Vector3 pt[3];
-
-	int idx[3];
-	int cmaxT = 0;
-	int cminT = 0;
-	bool chooseMin = false;
-
-	for (int j = 0; j < 3; ++ j)
-	{
-		idx[j] = (int)RandomValue(0, (Real)((int)rays.size() * 2 - 1));
-
-		if (idx[j] >= (int)rays.size())
-		{
-			idx[j] -= (int)rays.size();
-
-			chooseMin = (cminT < 2);
-		}
-		else
-			chooseMin = (cmaxT < 2);
-
-		RayInfo rayInf = rays[idx[j]];
-		pt[j] = chooseMin ? rayInf.ExtrapOrigin() : rayInf.ExtrapTermination();
-	}
-
-	return Plane3(pt[0], pt[1], pt[2]);
-}
-
-
-Plane3 VspBspTree::ChooseCandidatePlane3(const RayInfoContainer &rays) const
-{
-	Vector3 pt[3];
-
-	int idx1 = (int)RandomValue(0, (Real)((int)rays.size() - 1));
-	int idx2 = (int)RandomValue(0, (Real)((int)rays.size() - 1));
-
-	// check if rays different
-	if (idx1 == idx2)
-		idx2 = (idx2 + 1) % (int)rays.size();
-
-	const RayInfo ray1 = rays[idx1];
-	const RayInfo ray2 = rays[idx2];
-
-	// normal vector of the plane parallel to both lines
-	const Vector3 norm = Normalize(CrossProd(ray1.mRay->GetDir(), ray2.mRay->GetDir()));
-
-	// vector from line 1 to line 2
-	const Vector3 vd = ray2.ExtrapOrigin() - ray1.ExtrapOrigin();
-
-	// project vector on normal to get distance
-	const float dist = DotProd(vd, norm);
-
-	// point on plane lies halfway between the two planes
-	const Vector3 planePt = ray1.ExtrapOrigin() + norm * dist * 0.5;
-
-	return Plane3(norm, planePt);
-}
-
-
-inline void VspBspTree::GenerateUniqueIdsForPvs()
+inline void VspOspTree::GenerateUniqueIdsForPvs()
 {
 	Intersectable::NewMail(); sBackId = Intersectable::sMailId;
@@ -1842,6 +946,6 @@
 
 
-float VspBspTree::EvalRenderCostDecrease(const Plane3 &candidatePlane,
-										 const VspBspTraversalData &data) const
+float VspOspTree::EvalRenderCostDecrease(const Plane3 &candidatePlane,
+										 const VspOspTraversalData &data) const
 {
 	float pvsFront = 0;
@@ -1874,33 +978,9 @@
 	BspNodeGeometry geomFront;
 	BspNodeGeometry geomBack;
-
-	// construct child geometry with regard to the candidate split plane
-	data.mGeometry->SplitGeometry(geomFront,
-								  geomBack,
-								  candidatePlane,
-								  mBox,
-								  //0.0f);
-								  mEpsilon);
-
-	if (!mUseAreaForPvs) // use front and back cell areas to approximate volume
-	{
-		pFront = geomFront.GetVolume();
-		pBack = pOverall - pFront;
-
-		// something is wrong with the volume
-		if ((pFront < 0.0) || (pBack < 0.0))
-		{
-			Debug << "ERROR in volume:\n"
-				  << "volume f :" << pFront << " b: " << pBack << " p: " << pOverall 
-				  << ", real volume f: " << pFront << " b: " << geomBack.GetVolume()
-				  << ", #polygons f: " << geomFront.Size() << " b: " << geomBack.Size() << " p: " << data.mGeometry->Size() << endl;
-		}
-	}
-	else
-	{
-		pFront = geomFront.GetArea();
-		pBack = geomBack.GetArea();
-	}
-	
+	
+	pFront = geomFront.GetVolume();
+	pBack = pOverall - pFront;
+
+		
 
 	// -- pvs rendering heuristics
@@ -1921,8 +1001,6 @@
 
 #if 1
-	// take render cost of node into account
+	// take render cost of node into account to avoid being stuck in a local minimum
 	const float normalizedOldRenderCost = oldRenderCost / mBox.GetVolume();
-	//Debug << "rendercostdecr: " << 0.99f * renderCostDecrease << " old render cost: " << 0.01f * normalizedOldRenderCost << endl;
-	//return 0.5f * renderCostDecrease + 0.5f * normalizedOldRenderCost;
 	return 0.99f * renderCostDecrease + 0.01f * normalizedOldRenderCost;
 #else
@@ -1932,215 +1010,11 @@
 
 
-float VspBspTree::EvalSplitPlaneCost(const Plane3 &candidatePlane,
-									 const VspBspTraversalData &data,
-									 BspNodeGeometry &geomFront,
-									 BspNodeGeometry &geomBack,
-									 float &pFront,
-									 float &pBack) const
-{
-	float cost = 0;
-
-	float totalPvs = 0;
-	float pvsFront = 0;
-	float pvsBack = 0;
-	
-	// probability that view point lies in back / front node
-	float pOverall = 0;
-	pFront = 0;
-	pBack = 0;
-
-
-	int limit;
-	bool useRand;
-
-	// create unique ids for pvs heuristics
-	GenerateUniqueIdsForPvs();
-
-	// choose test rays randomly if too much
-	if ((int)data.mRays->size() > mMaxTests)
-	{
-		useRand = true;
-		limit = mMaxTests;
-	}
-	else
-	{
-		useRand = false;
-		limit = (int)data.mRays->size();
-	}
-	
-	for (int i = 0; i < limit; ++ i)
-	{
-		const int testIdx = useRand ? 
-			(int)RandomValue(0, (Real)((int)data.mRays->size() - 1)) : i;
-		RayInfo rayInf = (*data.mRays)[testIdx];
-
-		float t;
-		VssRay *ray = rayInf.mRay;
-		const int cf = rayInf.ComputeRayIntersection(candidatePlane, t);
-
-		// find front and back pvs for origing and termination object
-		AddObjToPvs(ray->mTerminationObject, cf, pvsFront, pvsBack, totalPvs);
-		AddObjToPvs(ray->mOriginObject, cf, pvsFront, pvsBack, totalPvs);
-	}
-
-	// construct child geometry with regard to the candidate split plane
-	bool splitSuccessFull = data.mGeometry->SplitGeometry(geomFront,
-														  geomBack,
-														  candidatePlane,
-														  mBox,
-														  //0.0f);
-														  mEpsilon);
-
-	pOverall = data.mProbability;
-
-	if (!mUseAreaForPvs) // use front and back cell areas to approximate volume
-	{
-		pFront = geomFront.GetVolume();
-		pBack = pOverall - pFront;
-		
-		// HACK: precision issues possible for unbalanced split => don't take this split!
-		if (1 && 
-			(!splitSuccessFull || (pFront <= 0) || (pBack <= 0) || 
-			!geomFront.Valid() || !geomBack.Valid()))
-		{
-			//Debug << "error f: " << pFront << " b: " << pBack << endl;
-			// high penalty for this split
-			return 99999.9f;
-		}
-	}
-	else
-	{
-		pFront = geomFront.GetArea();
-		pBack = geomBack.GetArea();
-	}
-	
-
-	// -- pvs rendering heuristics
-	const int lowerPvsLimit = mViewCellsManager->GetMinPvsSize();
-	const int upperPvsLimit = mViewCellsManager->GetMaxPvsSize();
-
-	// only render cost heuristics or combined with standard deviation
-	const float penaltyOld = EvalPvsPenalty((int)totalPvs, lowerPvsLimit, upperPvsLimit);
-    const float penaltyFront = EvalPvsPenalty((int)pvsFront, lowerPvsLimit, upperPvsLimit);
-	const float penaltyBack = EvalPvsPenalty((int)pvsBack, lowerPvsLimit, upperPvsLimit);
-			
-	const float oldRenderCost = pOverall * penaltyOld;
-	const float newRenderCost = penaltyFront * pFront + penaltyBack * pBack;
-
-	float oldCost, newCost;
-
-	// only render cost
-	if (1)
-	{
-		oldCost = oldRenderCost;
-		newCost = newRenderCost;
-	}
-	else // also considering standard deviation
-	{
-		// standard deviation is difference of back and front pvs
-		const float expectedCost = 0.5f * (penaltyFront + penaltyBack);
-
-		const float newDeviation = 0.5f * 
-			fabs(penaltyFront - expectedCost) + fabs(penaltyBack - expectedCost);
-
-		const float oldDeviation = penaltyOld;
-
-		newCost = mRenderCostWeight * newRenderCost + (1.0f - mRenderCostWeight) * newDeviation;
-		oldCost = mRenderCostWeight * oldRenderCost + (1.0f - mRenderCostWeight) * oldDeviation;
-	}
-
-	cost += mPvsFactor * newCost / (oldCost + Limits::Small);
-		
-
-#ifdef _DEBUG
-  	Debug << "totalpvs: " << data.mPvs << " ptotal: " << pOverall
-  		  << " frontpvs: " << pvsFront << " pFront: " << pFront
-  		  << " backpvs: " << pvsBack << " pBack: " << pBack << endl << endl;
-	Debug << "cost: " << cost << endl;
-#endif
-
-	return cost;
-}
-
-
-int VspBspTree::ComputeBoxIntersections(const AxisAlignedBox3 &box, 
-										ViewCellContainer &viewCells) const
-{
-	stack<bspNodePair> nodeStack;
-	BspNodeGeometry *rgeom = new BspNodeGeometry();
-
-	ConstructGeometry(mRoot, *rgeom);
-
-	nodeStack.push(bspNodePair(mRoot, rgeom));
-  
-	ViewCell::NewMail();
-
-	while (!nodeStack.empty()) 
-	{
-		BspNode *node = nodeStack.top().first;
-		BspNodeGeometry *geom = nodeStack.top().second;
-		nodeStack.pop();
-
-		const int side = geom->ComputeIntersection(box);
-		
-		switch (side)
-		{
-		case -1:
-			// node geometry is contained in box
-			CollectViewCells(node, true, viewCells, true);
-			break;
-
-		case 0:
-			if (node->IsLeaf())
-			{
-				BspLeaf *leaf = dynamic_cast<BspLeaf *>(node);
-			
-				if (!leaf->GetViewCell()->Mailed() && leaf->TreeValid())
-				{
-					leaf->GetViewCell()->Mail();
-					viewCells.push_back(leaf->GetViewCell());
-				}
-			}
-			else 
-			{
-				BspInterior *interior = dynamic_cast<BspInterior *>(node);
-			
-				BspNode *first = interior->GetFront();
-				BspNode *second = interior->GetBack();
-            
-				BspNodeGeometry *firstGeom = new BspNodeGeometry();
-				BspNodeGeometry *secondGeom = new BspNodeGeometry();
-
-				geom->SplitGeometry(*firstGeom,
-									*secondGeom,
-									interior->GetPlane(),
-									mBox,
-									//0.0000001f);
-									mEpsilon);
-
-				nodeStack.push(bspNodePair(first, firstGeom));
-				nodeStack.push(bspNodePair(second, secondGeom));
-			}
-			
-			break;
-		default:
-			// default: cull
-			break;
-		}
-		
-		DEL_PTR(geom);
-		
-	}
-
-	return (int)viewCells.size();
-}
-
-
-float VspBspTree::EvalAxisAlignedSplitCost(const VspBspTraversalData &data,
-										   const AxisAlignedBox3 &box,
-										   const int axis,
-										   const float &position,										  
-										   float &pFront,
-										   float &pBack) const
+
+float VspOspTree::EvalSplitCost(const VspOspTraversalData &data,
+								const AxisAlignedBox3 &box,
+								const int axis,
+								const float &position,										  
+								float &pFront,
+								float &pBack) const
 {
 	float pvsTotal = 0;
@@ -2158,6 +1032,4 @@
 	for(rit = data.mRays->begin(); rit != rit_end; ++ rit)
 	{
-		//if (!(*rit).mRay->IsActive())	continue;
-
 		// determine the side of this ray with respect to the plane
 		float t;
@@ -2175,31 +1047,7 @@
 		
 	pOverall = data.mProbability;
-
-	if (!mUseAreaForPvs)
-	{   // volume
-		pBack = pFront = pOverall * 0.5f;
-		
-#if 0
-		// box length substitute for probability
-		const float minBox = box.Min(axis);
-		const float maxBox = box.Max(axis);
-
-		pBack = position - minBox;
-		pFront = maxBox - position;
-		pOverall = maxBox - minBox;
-#endif
-	}
-	else //-- area substitute for probability
-	{
-		const int axis2 = (axis + 1) % 3;
-		const int axis3 = (axis + 2) % 3;
-
-		const float faceArea = 
-			(box.Max(axis2) - box.Min(axis2)) *
-			(box.Max(axis3) - box.Min(axis3));
-
-		pBack = pFront = pOverall * 0.5f + faceArea;
-	}
-
+	pBack = pFront = pOverall * 0.5f;
+	
+	
 #ifdef _DEBUG
 	Debug << axis << " " << pvsSize << " " << pvsBack << " " << pvsFront << endl;
@@ -2215,5 +1063,5 @@
 
 
-void VspBspTree::AddObjToPvs(Intersectable *obj,
+void VspOspTree::AddObjToPvs(Intersectable *obj,
 							 const int cf,
 							 float &frontPvs,
@@ -2268,5 +1116,5 @@
 
 
-void VspBspTree::CollectLeaves(vector<BspLeaf *> &leaves, 
+void VspOspTree::CollectLeaves(vector<BspLeaf *> &leaves, 
 							   const bool onlyUnmailed,
 							   const int maxPvsSize) const
@@ -2302,5 +1150,5 @@
 
 
-AxisAlignedBox3 VspBspTree::GetBoundingBox() const
+AxisAlignedBox3 VspOspTree::GetBoundingBox() const
 {
 	return mBox;
@@ -2308,5 +1156,5 @@
 
 
-BspNode *VspBspTree::GetRoot() const
+BspNode *VspOspTree::GetRoot() const
 {
 	return mRoot;
@@ -2314,5 +1162,5 @@
 
 
-void VspBspTree::EvaluateLeafStats(const VspBspTraversalData &data)
+void VspOspTree::EvaluateLeafStats(const VspOspTraversalData &data)
 {
 	// the node became a leaf -> evaluate stats for leafs
@@ -2370,5 +1218,5 @@
 
 
-int VspBspTree::CastRay(Ray &ray)
+int VspOspTree::CastRay(Ray &ray)
 {
 	int hits = 0;
@@ -2439,5 +1287,5 @@
 			if (!leaf->GetViewCell()->Mailed())
 			{
-				//ray.bspIntersections.push_back(Ray::VspBspIntersection(maxt, leaf));
+				//ray.bspIntersections.push_back(Ray::VspOspIntersection(maxt, leaf));
 				leaf->GetViewCell()->Mail();
 				++ hits;
@@ -2468,5 +1316,5 @@
 
 
-void VspBspTree::CollectViewCells(ViewCellContainer &viewCells, bool onlyValid) const
+void VspOspTree::CollectViewCells(ViewCellContainer &viewCells, bool onlyValid) const
 {
 	ViewCell::NewMail();
@@ -2476,5 +1324,5 @@
 
 
-void VspBspTree::CollapseViewCells()
+void VspOspTree::CollapseViewCells()
 {
 // TODO
@@ -2531,5 +1379,5 @@
 
 
-void VspBspTree::CollectRays(VssRayContainer &rays)
+void VspOspTree::CollectRays(VssRayContainer &rays)
 {
 	vector<BspLeaf *> leaves;
@@ -2548,5 +1396,5 @@
 
 
-void VspBspTree::ValidateTree()
+void VspOspTree::ValidateTree()
 {
 	stack<BspNode *> nodeStack;
@@ -2591,5 +1439,5 @@
 
 
-void VspBspTree::CollectViewCells(BspNode *root,
+void VspOspTree::CollectViewCells(BspNode *root,
 								  bool onlyValid,
 								  ViewCellContainer &viewCells,
@@ -2635,65 +1483,5 @@
 
 
-void VspBspTree::PreprocessPolygons(PolygonContainer &polys)
-{
-	// preprocess: throw out polygons coincident to the view space box (not needed)
-	PolygonContainer boxPolys;
-	mBox.ExtractPolys(boxPolys);
-	vector<Plane3> boxPlanes;
-
-	PolygonContainer::iterator pit, pit_end = boxPolys.end();
-
-	// extract planes of box
-	// TODO: can be done more elegantly than first extracting polygons
-	// and take their planes
-	for (pit = boxPolys.begin(); pit != pit_end; ++ pit)
-	{
-		boxPlanes.push_back((*pit)->GetSupportingPlane());
-	}
-
-	pit_end = polys.end();
-
-	for (pit = polys.begin(); pit != pit_end; ++ pit)
-	{
-		vector<Plane3>::const_iterator bit, bit_end = boxPlanes.end();
-		
-		for (bit = boxPlanes.begin(); (bit != bit_end) && (*pit); ++ bit)
-		{
-			const int cf = (*pit)->ClassifyPlane(*bit, mEpsilon);
-
-			if (cf == Polygon3::COINCIDENT)
-			{
-				DEL_PTR(*pit);
-				//Debug << "coincident!!" << endl;
-			}
-		}
-	}
-
-	// remove deleted entries
-	for (int i = 0; i < (int)polys.size(); ++ i)
-	{
-		while (!polys[i] && (i < (int)polys.size()))
-		{
-			swap(polys[i], polys.back());
-			polys.pop_back();
-		}
-	}
-}
-
-
-float VspBspTree::AccumulatedRayLength(const RayInfoContainer &rays) const
-{
-	float len = 0;
-
-	RayInfoContainer::const_iterator it, it_end = rays.end();
-
-	for (it = rays.begin(); it != it_end; ++ it)
-		len += (*it).SegmentLength();
-
-	return len;
-}
-
-
-int VspBspTree::SplitRays(const Plane3 &plane,
+int VspOspTree::SplitRays(const Plane3 &plane,
 						  RayInfoContainer &rays,
 						  RayInfoContainer &frontRays,
@@ -2725,5 +1513,5 @@
 			{
 				//-- split ray
-				//   test if start point behind or in front of plane
+				//-- test if start point behind or in front of plane
 				const int side = plane.Side(bRay.ExtrapOrigin());
 
@@ -2750,367 +1538,15 @@
 
 
-void VspBspTree::ExtractHalfSpaces(BspNode *n, vector<Plane3> &halfSpaces) const
-{
-	BspNode *lastNode;
-
-	do
-	{
-		lastNode = n;
-
-		// want to get planes defining geometry of this node => don't take
-		// split plane of node itself
-		n = n->GetParent();
-
-		if (n)
-		{
-			BspInterior *interior = dynamic_cast<BspInterior *>(n);
-			Plane3 halfSpace = dynamic_cast<BspInterior *>(interior)->GetPlane();
-
-            if (interior->GetBack() != lastNode)
-				halfSpace.ReverseOrientation();
-
-			halfSpaces.push_back(halfSpace);
-		}
-	}
-	while (n);
-}
-
-
-void VspBspTree::ConstructGeometry(BspNode *n,
-								   BspNodeGeometry &geom) const
-{
-	vector<Plane3> halfSpaces;
-	ExtractHalfSpaces(n, halfSpaces);
-
-	PolygonContainer candidatePolys;
-	vector<Plane3> candidatePlanes;
-
-	vector<Plane3>::const_iterator pit, pit_end = halfSpaces.end();
-
-	// bounded planes are added to the polygons
-	for (pit = halfSpaces.begin(); pit != pit_end; ++ pit)
-	{
-		Polygon3 *p = GetBoundingBox().CrossSection(*pit);
-
-		if (p->Valid(mEpsilon))
-		{
-			candidatePolys.push_back(p);
-			candidatePlanes.push_back(*pit);
-		}
-	}
-
-	// add faces of bounding box (also could be faces of the cell)
-	for (int i = 0; i < 6; ++ i)
-	{
-		VertexContainer vertices;
-
-		for (int j = 0; j < 4; ++ j)
-			vertices.push_back(mBox.GetFace(i).mVertices[j]);
-
-		Polygon3 *poly = new Polygon3(vertices);
-
-		candidatePolys.push_back(poly);
-		candidatePlanes.push_back(poly->GetSupportingPlane());
-	}
-
-	for (int i = 0; i < (int)candidatePolys.size(); ++ i)
-	{
-		// polygon is split by all other planes
-		for (int j = 0; (j < (int)halfSpaces.size()) && candidatePolys[i]; ++ j)
-		{
-			if (i == j) // polygon and plane are coincident
-				continue;
-
-			VertexContainer splitPts;
-			Polygon3 *frontPoly, *backPoly;
-
-			const int cf =
-				candidatePolys[i]->ClassifyPlane(halfSpaces[j],
-												 mEpsilon);
-
-			switch (cf)
-			{
-				case Polygon3::SPLIT:
-					frontPoly = new Polygon3();
-					backPoly = new Polygon3();
-
-					candidatePolys[i]->Split(halfSpaces[j],
-											 *frontPoly,
-											 *backPoly,
-											 mEpsilon);
-
-					DEL_PTR(candidatePolys[i]);
-
-					if (backPoly->Valid(mEpsilon))
-						candidatePolys[i] = backPoly;
-					else
-						DEL_PTR(backPoly);
-
-					// outside, don't need this
-					DEL_PTR(frontPoly);
-					break;
-				// polygon outside of halfspace
-				case Polygon3::FRONT_SIDE:
-					DEL_PTR(candidatePolys[i]);
-					break;
-				// just take polygon as it is
-				case Polygon3::BACK_SIDE:
-				case Polygon3::COINCIDENT:
-				default:
-					break;
-			}
-		}
-
-		if (candidatePolys[i])
-		{
-			geom.Add(candidatePolys[i], candidatePlanes[i]);
-			//	geom.mPolys.push_back(candidates[i]);
-		}
-	}
-}
-
-
-void VspBspTree::ConstructGeometry(ViewCell *vc, 
-								   BspNodeGeometry &vcGeom) const
-{
-	ViewCellContainer leaves;
-	
-	mViewCellsTree->CollectLeaves(vc, leaves);
-
-	ViewCellContainer::const_iterator it, it_end = leaves.end();
-
-	for (it = leaves.begin(); it != it_end; ++ it)
-	{
-		BspLeaf *l = dynamic_cast<BspViewCell *>(*it)->mLeaf;
-		
-		ConstructGeometry(l, vcGeom);
-	}
-}
-
-
-int VspBspTree::FindNeighbors(BspNode *n, vector<BspLeaf *> &neighbors,
+int VspOspTree::FindNeighbors(BspNode *n, vector<BspLeaf *> &neighbors,
 							  const bool onlyUnmailed) const
 {
-	stack<bspNodePair> nodeStack;
-	
-	BspNodeGeometry nodeGeom;
-	ConstructGeometry(n, nodeGeom);
-//	const float eps = 0.5f;
-	const float eps = 0.01f;
-	// split planes from the root to this node
-	// needed to verify that we found neighbor leaf
-	// TODO: really needed?
-	vector<Plane3> halfSpaces;
-	ExtractHalfSpaces(n, halfSpaces);
-
-
-	BspNodeGeometry *rgeom = new BspNodeGeometry();
-	ConstructGeometry(mRoot, *rgeom);
-
-	nodeStack.push(bspNodePair(mRoot, rgeom));
-
-	while (!nodeStack.empty())
-	{
-		BspNode *node = nodeStack.top().first;
-		BspNodeGeometry *geom = nodeStack.top().second;
-	
-		nodeStack.pop();
-
-		if (node->IsLeaf())
-		{
-			// test if this leaf is in valid view space
-			if (node->TreeValid() &&
-				(node != n) && 
-				(!onlyUnmailed || !node->Mailed()))
-			{
-				bool isAdjacent = true;
-
-				if (1)
-				{
-					// test all planes of current node if still adjacent
-					for (int i = 0; (i < halfSpaces.size()) && isAdjacent; ++ i)
-					{
-						const int cf =
-							Polygon3::ClassifyPlane(geom->GetPolys(),
-													halfSpaces[i],
-													eps);
-
-						if (cf == Polygon3::FRONT_SIDE)
-						{
-							isAdjacent = false;
-						}
-					}
-				}
-				else
-				{
-					// TODO: why is this wrong??
-					// test all planes of current node if still adjacent
-					for (int i = 0; (i < nodeGeom.Size()) && isAdjacent; ++ i)
-					{
-						Polygon3 *poly = nodeGeom.GetPolys()[i];
-
-						const int cf =
-							Polygon3::ClassifyPlane(geom->GetPolys(),
-													poly->GetSupportingPlane(),
-													eps);
-
-						if (cf == Polygon3::FRONT_SIDE)
-						{
-							isAdjacent = false;
-						}
-					}
-				}
-				// neighbor was found
-				if (isAdjacent)
-				{	
-					neighbors.push_back(dynamic_cast<BspLeaf *>(node));
-				}
-			}
-		}
-		else
-		{
-			BspInterior *interior = dynamic_cast<BspInterior *>(node);
-
-			const int cf = Polygon3::ClassifyPlane(nodeGeom.GetPolys(),
-												   interior->GetPlane(),
-												   eps);
-			
-			BspNode *front = interior->GetFront();
-			BspNode *back = interior->GetBack();
-            
-			BspNodeGeometry *fGeom = new BspNodeGeometry();
-			BspNodeGeometry *bGeom = new BspNodeGeometry();
-
-			geom->SplitGeometry(*fGeom,
-								*bGeom,
-								interior->GetPlane(),
-								mBox,
-								//0.0000001f);
-								eps);
-		
-			if (cf == Polygon3::BACK_SIDE)
-			{
-				nodeStack.push(bspNodePair(interior->GetBack(), bGeom));
-				DEL_PTR(fGeom);
-			}
-			else
-			{
-				if (cf == Polygon3::FRONT_SIDE)
-				{
-					nodeStack.push(bspNodePair(interior->GetFront(), fGeom));
-					DEL_PTR(bGeom);
-				}
-				else
-				{	// random decision
-					nodeStack.push(bspNodePair(front, fGeom));
-					nodeStack.push(bspNodePair(back, bGeom));
-				}
-			}
-		}
-	
-		DEL_PTR(geom);
-	}
-
-	return (int)neighbors.size();
-}
-
-
-
-int VspBspTree::FindApproximateNeighbors(BspNode *n, 
-										 vector<BspLeaf *> &neighbors,
-										 const bool onlyUnmailed) const
-{
-	stack<bspNodePair> nodeStack;
-	
-	BspNodeGeometry nodeGeom;
-	ConstructGeometry(n, nodeGeom);
-	
-	float eps = 0.01f;
-	// split planes from the root to this node
-	// needed to verify that we found neighbor leaf
-	// TODO: really needed?
-	vector<Plane3> halfSpaces;
-	ExtractHalfSpaces(n, halfSpaces);
-
-
-	BspNodeGeometry *rgeom = new BspNodeGeometry();
-	ConstructGeometry(mRoot, *rgeom);
-
-	nodeStack.push(bspNodePair(mRoot, rgeom));
-
-	while (!nodeStack.empty())
-	{
-		BspNode *node = nodeStack.top().first;
-		BspNodeGeometry *geom = nodeStack.top().second;
-	
-		nodeStack.pop();
-
-		if (node->IsLeaf())
-		{
-			// test if this leaf is in valid view space
-			if (node->TreeValid() &&
-				(node != n) && 
-				(!onlyUnmailed || !node->Mailed()))
-			{
-				bool isAdjacent = true;
-
-				// neighbor was found
-				if (isAdjacent)
-				{	
-					neighbors.push_back(dynamic_cast<BspLeaf *>(node));
-				}
-			}
-		}
-		else
-		{
-			BspInterior *interior = dynamic_cast<BspInterior *>(node);
-
-			const int cf = Polygon3::ClassifyPlane(nodeGeom.GetPolys(),
-												   interior->GetPlane(),
-												   eps);
-			
-			BspNode *front = interior->GetFront();
-			BspNode *back = interior->GetBack();
-            
-			BspNodeGeometry *fGeom = new BspNodeGeometry();
-			BspNodeGeometry *bGeom = new BspNodeGeometry();
-
-			geom->SplitGeometry(*fGeom,
-								*bGeom,
-								interior->GetPlane(),
-								mBox,
-								//0.0000001f);
-								eps);
-		
-			if (cf == Polygon3::BACK_SIDE)
-			{
-				nodeStack.push(bspNodePair(interior->GetBack(), bGeom));
-				DEL_PTR(fGeom);
-				}
-			else
-			{
-				if (cf == Polygon3::FRONT_SIDE)
-				{
-					nodeStack.push(bspNodePair(interior->GetFront(), fGeom));
-					DEL_PTR(bGeom);
-				}
-				else
-				{	// random decision
-					nodeStack.push(bspNodePair(front, fGeom));
-					nodeStack.push(bspNodePair(back, bGeom));
-				}
-			}
-		}
-	
-		DEL_PTR(geom);
-	}
-
-	return (int)neighbors.size();
-}
-
-
-
-BspLeaf *VspBspTree::GetRandomLeaf(const Plane3 &halfspace)
-{
+	// TODO
+	return 0;
+}
+
+
+BspLeaf *VspOspTree::GetRandomLeaf(const Plane3 &halfspace)
+{
+#if TODO
     stack<BspNode *> nodeStack;
   	nodeStack.push(mRoot);
@@ -3157,10 +1593,10 @@
 		}
 	}
-
+#endif
 	return NULL;
 }
 
 
-BspLeaf *VspBspTree::GetRandomLeaf(const bool onlyUnmailed)
+BspLeaf *VspOspTree::GetRandomLeaf(const bool onlyUnmailed)
 {
 	stack<BspNode *> nodeStack;
@@ -3198,5 +1634,5 @@
 
 
-int VspBspTree::ComputePvsSize(const RayInfoContainer &rays) const
+int VspOspTree::ComputePvsSize(const RayInfoContainer &rays) const
 {
 	int pvsSize = 0;
@@ -3232,5 +1668,5 @@
 
 
-float VspBspTree::GetEpsilon() const
+float VspOspTree::GetEpsilon() const
 {
 	return mEpsilon;
